summaryrefslogtreecommitdiff
path: root/scripts
diff options
context:
space:
mode:
authorAleš Smodiš <aless@guru.si>2015-10-17 22:06:18 +0200
committerAleš Smodiš <aless@guru.si>2015-10-17 22:06:18 +0200
commit8893bb730b7d4127f1e4f8a47146d5dfb9300c81 (patch)
tree8caec96890db6348ac932641e1b25320ddfa9615 /scripts
parent79c4800ac99c24400ad9da91101b48d6a55234b9 (diff)
Implemented init script for the SAML daemon, modified the refresh-and-deploy script accordingly.
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/deploy/codeq_refresh_and_deploy.sh29
-rw-r--r--scripts/systemd/codeq2
-rw-r--r--scripts/systemd/codeq-saml.service13
-rw-r--r--scripts/sysvinit/codeq2
-rw-r--r--scripts/sysvinit/codeq-saml141
-rwxr-xr-xscripts/sysvinit/codeq-web1
6 files changed, 185 insertions, 3 deletions
diff --git a/scripts/deploy/codeq_refresh_and_deploy.sh b/scripts/deploy/codeq_refresh_and_deploy.sh
index e44739b..966737b 100755
--- a/scripts/deploy/codeq_refresh_and_deploy.sh
+++ b/scripts/deploy/codeq_refresh_and_deploy.sh
@@ -8,6 +8,7 @@ export CODEQ_PROBLEMS CODEQ_WEB_OUTPUT CODEQ_DB_HOST CODEQ_DB_DATABASE CODEQ_DB_
RESTART_PROLOG=0
RESTART_SERVER=0
RESTART_WEB=0
+RESTART_SAML=0
BUILD_WEB_RESOURCES=0
init=$(cat /proc/1/comm)
@@ -24,7 +25,7 @@ if git diff --name-status origin/$CODEQ_GIT_BRANCH | cut -c3- | grep -v \\.gitig
RESTART_PROLOG=1
fi
- if grep -q -v '^\(web\|prolog/runner\|scripts\)/' $FILES; then
+ if grep -qv '^\(web\|saml\|prolog/runner\|scripts\)/' $FILES; then
RESTART_SERVER=1
fi
@@ -32,6 +33,10 @@ if git diff --name-status origin/$CODEQ_GIT_BRANCH | cut -c3- | grep -v \\.gitig
RESTART_WEB=1
fi
+ if grep -q ^saml/ $FILES; then
+ RESTART_SAML=1
+ fi
+
if grep -q ^scripts/build_web_resources.py $FILES; then
BUILD_WEB_RESOURCES=1
fi
@@ -43,9 +48,14 @@ if git diff --name-status origin/$CODEQ_GIT_BRANCH | cut -c3- | grep -v \\.gitig
fi
done
- if grep -q ^web/ $FILES | grep -v ^web/main.js; then
+ if grep ^web/ $FILES | grep -qv ^web/main.js; then
+ # node dependencies may have changed, run installation
+ cd $CODEQ_SERVER/web && /usr/bin/npm install
+ fi
+
+ if grep ^saml/ $FILES | grep -qv ^saml/saml.js; then
# node dependencies may have changed, run installation
- cd web && /usr/bin/npm install
+ cd $CODEQ_SERVER/saml && /usr/bin/npm install
fi
fi
@@ -102,5 +112,18 @@ if [ $RESTART_WEB -ne 0 ]; then
/etc/init.d/codeq-web restart
fi
fi
+if [ $RESTART_SAML -ne 0 ]; then
+ if [ "$init" = systemd ]; then
+ if systemctl list-unit-files codeq-saml.service|grep -q codeq-saml.service; then
+ echo Restarting codeq-saml
+ systemctl restart codeq-saml
+ fi
+ else
+ if [ -x /etc/init.d/codeq-saml ]; then
+ echo Restarting codeq-saml
+ /etc/init.d/codeq-saml restart
+ fi
+ fi
+fi
exit 0
diff --git a/scripts/systemd/codeq b/scripts/systemd/codeq
index 28b133b..e6c79ec 100644
--- a/scripts/systemd/codeq
+++ b/scripts/systemd/codeq
@@ -10,3 +10,5 @@ CODEQ_DB_PASS=c0d3q
CODEQ_SERVER_LOG=/var/log/codeq-server.log
CODEQ_WEB_LOG=/var/log/codeq-web.log
CODEQ_GIT_BRANCH=release
+CODEQ_SAML_SERVICE_URL=https://codeq.si/Shibboleth.sso/
+CODEQ_SAML_LOG=/var/log/codeq-saml.log
diff --git a/scripts/systemd/codeq-saml.service b/scripts/systemd/codeq-saml.service
new file mode 100644
index 0000000..5926daf
--- /dev/null
+++ b/scripts/systemd/codeq-saml.service
@@ -0,0 +1,13 @@
+# /etc/systemd/system/codeq-saml.service
+[Unit]
+After=network.target
+Description=CodeQ SAML services
+
+[Service]
+ExecStart=/usr/bin/nodejs /var/local/codeq-server/saml/saml.js
+Restart=on-failure
+Type=simple
+StandardInput=null
+StandardOutput=null
+StandardError=null
+EnvironmentFile=-/etc/default/codeq
diff --git a/scripts/sysvinit/codeq b/scripts/sysvinit/codeq
index 28b92a1..f6a0968 100644
--- a/scripts/sysvinit/codeq
+++ b/scripts/sysvinit/codeq
@@ -10,3 +10,5 @@ CODEQ_DB_PASS=c0d3q
CODEQ_SERVER_LOG=/var/log/codeq-server.log
CODEQ_WEB_LOG=/var/log/codeq-web.log
CODEQ_GIT_BRANCH=master
+CODEQ_SAML_SERVICE_URL=https://codeq.si/Shibboleth.sso/
+CODEQ_SAML_LOG=/var/log/codeq-saml.log
diff --git a/scripts/sysvinit/codeq-saml b/scripts/sysvinit/codeq-saml
new file mode 100644
index 0000000..c11f429
--- /dev/null
+++ b/scripts/sysvinit/codeq-saml
@@ -0,0 +1,141 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides: codeq-saml
+# Required-Start: $local_fs $remote_fs $network
+# Required-Stop: $local_fs $remote_fs
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: CodeQ SAML services initscript
+# Description: Init script for running CodeQ SAML services as a daemon
+### END INIT INFO
+
+# Author: Aleš Smodiš <aless@guru.si>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="CodeQ SAML services daemon"
+NAME=codeq-saml
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Read configuration variable file if it is present
+[ -r /etc/default/codeq ] && . /etc/default/codeq
+
+NODEJS=/usr/bin/nodejs
+SCRIPT=$CODEQ_SERVER/saml/saml.js
+
+# Exit if Node is not installed
+[ -x "$NODEJS" ] || exit 0
+# Exit if the script does not exist
+[ -f "$SCRIPT" ] || exit 0
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ export CODEQ_SAML_LOG
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $NODEJS --background --make-pidfile --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $NODEJS --background --make-pidfile -- $SCRIPT \
+ || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --pidfile $PIDFILE --retry=TERM/15/KILL/5 --remove-pidfile
+ RETVAL="$?"
+ return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+ #
+ # If the daemon can reload its configuration without
+ # restarting (for example, when it is sent a SIGHUP),
+ # then implement that here.
+ #
+ start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+ return 0
+}
+
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ status_of_proc -p $PIDFILE "$NODEJS" $NAME && exit 0 || exit $?
+ ;;
+ #reload|force-reload)
+ #
+ # If do_reload() is not implemented then leave this commented out
+ # and leave 'force-reload' as an alias for 'restart'.
+ #
+ #log_daemon_msg "Reloading $DESC"
+ #do_reload
+ #log_end_msg $?
+ #;;
+ restart|force-reload)
+ #
+ # If the "reload" option is implemented then remove the
+ # 'force-reload' alias
+ #
+ log_daemon_msg "Restarting $DESC"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
+esac
diff --git a/scripts/sysvinit/codeq-web b/scripts/sysvinit/codeq-web
index 56a2f35..98f1e74 100755
--- a/scripts/sysvinit/codeq-web
+++ b/scripts/sysvinit/codeq-web
@@ -49,6 +49,7 @@ do_start()
# 1 if daemon was already running
# 2 if daemon could not be started
export CODEQ_WEB_LOG
+ export CODEQ_SAML_SERVICE_URL
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $NODEJS --background --make-pidfile --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $NODEJS --background --make-pidfile -- $SCRIPT \